<!-- Ball and beam Model

State-Space (name/joint/parameter):

THIS IS THE CARTPOLE CONVERT THIS TO BALL AND BEAM
-
Sahand stinkt

Actuators (name/actuator/parameter):

- cart      motor       force x (N)
-->
<mujoco model='ballandbeam'>
  <compiler inertiafromgeom='true' coordinate='local'/>

  <size nkey="1"/>

  <asset>
    <texture name="grid" type="2d" builtin="checker" width="512" height="512" rgb1=".1 .2 .3" rgb2=".2 .3 .4"/>
    <material name="grid" texture="grid" texrepeat="1 1" texuniform="true" reflectance=".2"/>
  </asset>

  <default>
<!--    <joint damping='0.0001' solreflimit='.08 1'/>-->
    <default class="no_collision">
      <geom contype="0" conaffinity="0" group="2" friction='1.0 0.0 0.0'/>
    </default>
    <default class="passive_hinge">
      <joint damping="0.00"  frictionloss="0" stiffness="0"/>
    </default>
    <default class="actuator_hinge">
      <joint damping="0.1"  frictionloss="0" stiffness="0"/>
    </default>
    <default class="slider">
      <joint damping="0.001"  frictionloss="0" stiffness="0"/>
    </default>
  </default>


  <worldbody>
    <geom name="floor" pos = '0 0 -0.21275' size="0 0 .05"  type="plane" material="grid" conaffinity="15" condim="3"/>
    <light name="spotlight" mode="targetbodycom" target="base_for_hinge"
           diffuse=".8 .8 .8" specular="0.3 0.3 0.3" pos="0 -20 4" cutoff="10"/>
    <camera name='fixed' pos='0 0 0' quat='0.707 0.707 0 0'/>
    <body name = "base_for_hinge" pos = "-0.21275 0 0">
      <geom name = "base" pos = '0 0 -0.075' type = 'box' size = '0.013 0.02667 0.15' rgba = '0.5 0.2 0.4 0.3' mass = '1' class="no_collision"/>
      <body name='railbody' pos = '0 .0 0.08' >
        <geom name='rail1' type='capsule' pos='0.21275 0.01 0' quat='0.70710678118  0 0.70710678118  0'
            size='0.005 0.21275' mass='0.293' class="no_collision"/>
        <geom name='rail2' type='capsule' pos='0.21275 -0.01 0' quat='0.70710678118  0 0.70710678118  0'
            size='0.005 0.21275' mass = '0.293' class="no_collision"/>
        <joint name = "base_hinge2" type = 'hinge' pos = '0 -0.01 0' axis = '0 1 0' class="passive_hinge"/>
        <body name='ball' pos='0.21275 0 0'>
          <geom name = 'ball' type = 'sphere' size='0.0127' pos='0 0 0' mass = '0.064' rgba = '0.1 0.1 0.8 1' class="no_collision"/>
          <joint name='slider' type='slide' pos='0 0 0' axis='1 0 0' limited='true' range='-0.21275 0.21275' class="slider"/>
        </body>
        <body name = "stick_attached_to_stick" pos = '0.4255 0 -0.06' >
            <joint name = 'stick_hinge' type ='hinge' pos='0 0 0.06' axis = '0 1 0' class="passive_hinge"/>
            <geom name = 'stick2' pos = '0.0 0 0.0' type='cylinder' size = '0.01 0.06' rgba = '0.2 0.7 0.4 0.3' mass = '0.05' class="no_collision"/>
        </body>
      </body>
    </body>



    <body name = "rotator_system" pos = '0.13275 0 -0.04' >
      <body name = "motor_fixture" pos = '0 0 0' >
        <geom name = "fixed_point" type = 'cylinder' size ='0.01 0.01' pos = '0 0 0' quat='0 0 0.70710678118 0.70710678118 ' rgba = '0.2 0.9 0.3 0.3' class="no_collision"/>
<!--        <joint name = 'actuator' type = 'hinge' pos = '0 0 0' axis = '0 1 0' class="actuator_hinge"/>-->
        <body name="end_stick">
          <geom name = 'stick1' pos = '0.04 0 0.0' type='cylinder' size = '0.01 0.04' mass = '0.01' rgba = '0.5 0.2 0.4 0.3'
          quat='0.70710678118  0 0.70710678118  0' class="no_collision"/>
        </body>
      </body>


    </body>
  </worldbody>

<!--  <actuator>-->
<!--    <motor name='rotator_joint' joint='actuator' gear='1' ctrllimited='true' ctrlrange='-1 1' />-->
<!--  </actuator>-->

  <equality>
    <connect name = "fix_site" body1 ="end_stick" body2 = "stick_attached_to_stick" anchor='0.08 0 0.0' solref="0.0001 1"/>
  </equality>


<!--  <sensor>-->
<!--    <jointpos joint='actuator' />-->
<!--    <jointpos joint="slider"/>-->
<!--    &lt;!&ndash; <accelerometer name='spd' site='cart sensor'/> &ndash;&gt;-->
<!--    &lt;!&ndash; <touch name="collision" site="cart sensor"/> &ndash;&gt;-->
<!--  </sensor>-->

  <keyframe>
    <!-- <key name="hanging_down" qpos="0 1.57"/> -->
  </keyframe>

</mujoco>
